<?php
/*
////////////////////////////////////////////////////////////////////////////////
// JohnCMS                             Content Management System              //
// Di situs resmi dari proyek site:      http://johncms.com                     //
// Tambahan dukungan situs:      http://gazenwagen.com                  //
// Skrip asli
menggunakan bahasa rusia
   //
// Translate by : jogerplay
http://saparakanca.zat.su
////////////////////////////////////////////////////////////////////////////////
// JohnCMS core team:                                                         //
// Evgeniy Ryabinin alias john77 john77@gazenwagen.com                  //
// Oleg Kasyanov alias AlkatraZ          alkatraz@gazenwagen.com                //
//                                                                            //
// Versi informasi, melihat file terlampir, version.txt              //
////////////////////////////////////////////////////////////////////////////////
*/

defined('_IN_JOHNCMS') or die('Error:restricted access');

Error_Reporting(E_ALL & ~ E_NOTICE);
Error_Reporting(ERROR | WARNING);
mb_internal_encoding('UTF-8');

if (!isset($rootpath))
    $rootpath = '../';

////////////////////////////////////////////////////////////
// Hapus slashes jika  magic_quotes_gpc dibuka       //
////////////////////////////////////////////////////////////
if (get_magic_quotes_gpc())
{
    $in = array(&$_GET, &$_POST, &$_COOKIE);
    while (list($k, $v) = each($in))
    {
        foreach ($v as $key => $val)
        {
            if (!is_array($val))
            {
                $in[$k][$key] = stripslashes($val);
                continue;
            }
            $in[] = &$in[$k][$key];
        }
    }
    unset($in);
    if (!empty($_FILES))
    {
        foreach ($_FILES as $k => $v)
        {
            $_FILES[$k]['name'] = stripslashes((string )$v['name']);
        }
    }
}

////////////////////////////////////////////////////////////
// Mendapatkan dan penyaringan variable dasar untuk sistem   //
////////////////////////////////////////////////////////////
$id = isset($_REQUEST['id']) ? abs(intval($_REQUEST['id'])) : false; // id
$page = isset($_GET['page']) ? abs(intval($_GET['page'])) : 1; // jumlah halaman
$start = isset($_GET['start']) ? abs(intval($_GET['start'])) : 0; // untuk halaman oleh halaman navigasi
$act = isset($_GET['act']) ? trim($_GET['act']) : ''; // Pilihan tindakan
$agn = htmlentities(substr($_SERVER['HTTP_USER_AGENT'], 0, 100), ENT_QUOTES); // User Agent

////////////////////////////////////////////////////////////
// 1) mendapatkan IP real                                //
// 2) sebagai upaya untuk memeriksa HTTP banjir                     //
////////////////////////////////////////////////////////////
require_once ($rootpath . 'incfiles/class_ipinit.php');
$ipinit = new ipinit();
$ipl = $ipinit->ip;
$ipp = long2ip($ipl);
unset($ipinit);

// Startuem sesi
session_name("SESID");
session_start();

////////////////////////////////////////////////////////////
// Menghubungkan ke database                             //
////////////////////////////////////////////////////////////
require_once ($rootpath . 'incfiles/db.php');
$connect = @mysql_connect($db_host, $db_user, $db_pass) or die('cannot connect to server');
@mysql_select_db($db_name) or die('cannot connect to db');
@mysql_query("SET NAMES 'utf8'", $connect);

////////////////////////////////////////////////////////////
// Periksa alamat IP untuk ban                              //
////////////////////////////////////////////////////////////
$req = mysql_query("SELECT `ban_type`, `link` FROM `cms_ban_ip` WHERE '" . $ipl . "' BETWEEN `ip1` AND `ip2` LIMIT 1;") or die('Error: table "cms_ban_ip"');
if (mysql_num_rows($req) > 0)
{
    $res = mysql_fetch_array($req);
    switch ($res['ban_type'])
    {
        case 2:
            // Redirect link
            if (!empty($res['link']))
            {
                header("Location: " . $res['link']);
                exit;
            } else
            {
                header("Location: http://gazenwagen.com");
                exit;
            }
            break;
        case 3:
            // menutup log
            $regban = true;
            break;
        default:
            // Total larangan akses ke situs
            header("HTTP/1.0 404 Not Found");
            exit;
    }
}

////////////////////////////////////////////////////////////
// Pengaturan dasar                             //
////////////////////////////////////////////////////////////
$kmess = 10; // jumlah pesan ke buku tamu
$sdvig = 0; // waktu shift untuk tamu
$user_id = false;
$user_ps = false;
$dostsadm = 0;
$dostadm = 0;
$dostsmod = 0;
$dostlmod = 0;
$dostdmod = 0;
$dostfmod = 0;
$dostcmod = 0;
$dostkmod = 0;
$dostmod = 0;
$rights = 0;
$req = mysql_query("SELECT * FROM `cms_settings`;");
$set = array();
while ($res = mysql_fetch_row($req))
    $set[$res[0]] = $res[1];
mysql_free_result($req);
$nickadmina = $set['nickadmina']; // Nick 1 st admin
$nickadmina2 = $set['nickadmina2']; // Nick 2 nd (tersembunyi) admin
$emailadmina = $set['emailadmina']; // E-mail Administrator
$sdvigclock = $set['sdvigclock']; // waktu regu standar untuk sistem
$copyright = $set['copyright']; // kopriayt situs
$home = $set['homeurl']; // Home
$ras_pages = $set['rashstr']; // perluasan teks halaman
$admp = $set['admp']; // folder dengan admin
$flsz = $set['flsz']; // Maksimum ukuran file
$skindef = $set['skindef']; // default kulit untuk kamu

////////////////////////////////////////////////////////////
// Tanggal dan waktu                                           //
////////////////////////////////////////////////////////////
date_default_timezone_set('Europe/Moscow');
$realtime = time() + $sdvigclock * 3600;
$mon = date("m", $realtime);
if (substr($mon, 0, 1) == 0)
{
    $mon = str_replace("0", "", $mon);
}
$day = date("d", $realtime);
if (substr($day, 0, 1) == 0)
{
    $day = str_replace("0", "", $day);
}
$mesyac = array(1 => "Januari", "Februari", "Maret", "April", "Mei", "Juni", "Juli", "Agustus", "September", "Oktober", "November", "Desember");

////////////////////////////////////////////////////////////
// Avtoochistka sistem                                    //
////////////////////////////////////////////////////////////
if ($set['clean_time'] <= ($realtime - 43200))
{
    // Membersihkan table "count"
    mysql_query("delete from `count` where `time`<='" . ($realtime - 600) . "';");
    mysql_query("OPTIMIZE TABLE `count`;");
    mysql_query("UPDATE `cms_settings` SET  `val`='" . $realtime . "' WHERE `key`='clean_time';");
}

////////////////////////////////////////////////////////////
// Otorisasi untuk sesi                                  //
////////////////////////////////////////////////////////////
if (isset($_SESSION['uid']) && isset($_SESSION['ups']))
{
    $user_id = intval($_SESSION['uid']);
    $user_ps = $_SESSION['ups'];
}

////////////////////////////////////////////////////////////
// Otorisasi untuk COOKIE                                  //
////////////////////////////////////////////////////////////
elseif (isset($_COOKIE['cuid']) && isset($_COOKIE['cups']))
{
    $user_id = intval(base64_decode($_COOKIE['cuid']));
    $_SESSION['uid'] = $user_id;
    $user_ps = md5(md5(base64_decode($_COOKIE['cups'])));
    $_SESSION['ups'] = $user_ps;
    $cookauth = true;
}

////////////////////////////////////////////////////////////
// Query database ke user                          //
////////////////////////////////////////////////////////////
if ($user_id && $user_ps)
{
    $req = mysql_query("SELECT * FROM `users` WHERE `id`='" . $user_id . "' LIMIT 1;");
    if (mysql_num_rows($req) != 0)
    {
        $datauser = mysql_fetch_array($req);
        if ($user_ps === $datauser['password'])
        {
            // Dapatkan pengaturan pengguna
            $idus = $user_id;
            $skin = $datauser['skin']; // kulit pengguna
            $login = $datauser['name']; // Login (Nick) pengguna
            $sdvig = $datauser['sdvig']; // Offset waktu
            $kmess = $datauser['kolanywhwere']; // jumlah pesan per halaman
            $offpg = $datauser['offpg'];
            $offtr = $datauser['offtr'] ? 0 : 1; // Nonaktifkan translit
            $offsm = $datauser['offsm'] ? 0 : 1; // Nonaktifkan Smilies
            $upfp = $datauser['upfp'];
            $nmenu = $datauser['nmenu'];
            $chmes = $datauser['chmes'];
            $rights = $datauser['rights'];
            $lastdate = $datauser['lastdate'];
            $lastpost = $datauser['lastpost'];
            mysql_free_result($req);

            ////////////////////////////////////////////////////////////
            // periksa pengguna ban                                  //
            ////////////////////////////////////////////////////////////
            $req = mysql_query("SELECT * FROM `cms_ban_users` WHERE `user_id`='" . $user_id . "' AND `ban_time`>'" . $realtime . "';") or die('Error: table "cms_ban_users"');
            if (mysql_num_rows($req) != 0)
            {
                $rights = 0;
                $ban = array();
                while ($res = mysql_fetch_row($req))
                    $ban[$res[4]] = 1;
                mysql_free_result($req);
                if (isset($ban['9']))
                {
                    header("HTTP/1.0 404 Not Found");
                    exit;
                }
            }

            // Pengaturan akses administratif
            if ($login == $nickadmina || $login == $nickadmina2)
            {
                $dostsadm = 1;
            }
            if ($login == $nickadmina || $login == $nickadmina2 || $rights == 7)
            {
                $dostadm = 1;
            }
            if ($login == $nickadmina || $login == $nickadmina2 || $rights == 7 || $rights == 6)
            {
                $dostsmod = 1;
            }
            if ($login == $nickadmina || $login == $nickadmina2 || $rights == 7 || $rights == 6 || $rights == 5)
            {
                $dostlmod = 1;
            }
            if ($login == $nickadmina || $login == $nickadmina2 || $rights == 7 || $rights == 6 || $rights == 4)
            {
                $dostdmod = 1;
            }
            if ($login == $nickadmina || $login == $nickadmina2 || $rights == 7 || $rights == 6 || $rights == 3)
            {
                $dostfmod = 1;
            }
            if ($login == $nickadmina || $login == $nickadmina2 || $rights == 7 || $rights == 6 || $rights == 2)
            {
                $dostcmod = 1;
            }
            if ($login == $nickadmina || $login == $nickadmina2 || $rights == 1 || $rights == 7 || $rights == 6)
            {
                $dostkmod = 1;
            }
            if ($login == $nickadmina || $login == $nickadmina2 || $rights >= 1)
            {
                $dostmod = 1;
            }

            // mengatur waktu mulai untuk sesi
            if ($lastdate <= ($realtime - 300))
                mysql_query("UPDATE `users` SET `sestime`='" . $realtime . "' WHERE `id`='" . $user_id . "';");

            // Update data
            $totalonsite = $datauser['total_on_site'];
            if ($lastdate >= ($realtime - 300))
                $totalonsite = $totalonsite + $realtime - $lastdate;
            mysql_query("UPDATE `users` SET
         `total_on_site`='" . $totalonsite . "',
         `lastdate`='" . $realtime . "',
         `ip`='" . $ipl . "',
         `browser`='" . mysql_real_escape_string($agn) . "'
         WHERE `id`='" . $user_id . "';");

            // Jika pengguna tidak di situs selama 1 jam menunjukan st Digest
            if ($lastdate < ($realtime - 3600) && $datauser['digest'] == 1 && $headmod == 'mainpage')
                header("Location: " . $home . "/index.php?mod=digest&last=" . $lastdate);
        } else
        {
            // Jika password tidak cocok,keluarkan variabel sesi dan cookie bersih
            unset($_SESSION['uid']);
            unset($_SESSION['ups']);
            setcookie('cuid', '');
            setcookie('cups', '');
            $user_id = false;
            $user_ps = false;
        }
    } else
    {
        // Jika pengguna tidak ditemukan,merusak variabel sesi dan cookie bersih
        unset($_SESSION['uid']);
        unset($_SESSION['ups']);
        setcookie('cuid', '');
        setcookie('cups', '');
        $user_id = false;
        $user_ps = false;
    }
}

// Hubungkan file tambahan
require_once ($rootpath . 'incfiles/func.php');

// Update variabel
$start = isset($_GET['page']) ? $page * $kmess - $kmess : $start;

// Output Bufferizatsiya
if ($set['gzip'] == 1)
{
    ob_start('ob_gzhandler');
} else
{
    ob_start();
}

?>
