<?php
/*
////////////////////////////////////////////////////////////////////////////////
// JohnCMS                             Content Management System              //
// Di situs resmi dari proyek site:      http://johncms.com                     //
// Tambahan dukungan situs:      http://gazenwagen.com                  //
// Skrip asli
menggunakan bahasa rusia
   //
// Translate by : jogerplay
http://saparakanca.zat.su
////////////////////////////////////////////////////////////////////////////////
// JohnCMS core team:                                                         //
// Evgeniy Ryabinin alias john77 john77@gazenwagen.com                  //
// Oleg Kasyanov alias AlkatraZ          alkatraz@gazenwagen.com                //
//                                                                            //
// Versi informasi, melihat file terlampir, version.txt              //
////////////////////////////////////////////////////////////////////////////////
*/

define('_IN_JOHNCMS', 1);

$textl = 'Admin';
require_once ("../incfiles/core.php");
require_once ("../incfiles/head.php");

if ($dostadm == 1)
{
    $do = isset($_GET['do']) ? $_GET['do'] : '';
    switch ($do)
    {
        case 'new':
            ////////////////////////////////////////////////////////////
            // Alamat IP Banim, Formulir entri dan pengolahan       //
            ////////////////////////////////////////////////////////////
            echo '<div class="phdr"><b>Banim IP</b></div>';
            if (isset($_POST['submit']))
            {
                $error = '';
                $ip = isset($_POST['ip']) ? trim($_POST['ip']) : '';
                $ban_term = isset($_POST['term']) ? intval($_POST['term']) : 1;
                $ban_url = isset($_POST['url']) ? htmlentities(trim($_POST['url']), ENT_QUOTES, 'UTF-8') : '';
                $reason = isset($_POST['reason']) ? htmlentities(trim($_POST['reason']), ENT_QUOTES, 'UTF-8') : '';
                if (empty($ip))
                {
                    echo '<p>ERROR!<br />Jangan masukan IP<br /><a href="ipban.php?do=new">Kembali</a></p>';
                    require_once ("../incfiles/end.php");
                    exit;
                }
                $ip = str_replace(' ', '', $ip); // menghilangkan spasi
                if (stristr($ip, '-'))
                {
                    ////////////////////////////////////////////////////////////
                    // Proses rentang alamat                          //
                    ////////////////////////////////////////////////////////////
                    if (!ereg("^([0-9]{1,3})\.([0-9]{1,3})\.([0-9]{1,3})\.([0-9]{1,3})\-([0-9]{1,3})\.([0-9]{1,3})\.([0-9]{1,3})\.([0-9]{1,3})$", $ip))
                        $error = 'Wrong diperkenalkan rentang alamat IP';
                    if (!$error)
                    {
                        $iparr = explode('-', $ip);
                        $ip1 = ip2long($iparr[0]);
                        $ip2 = ip2long($iparr[1]);
                        $mode = 1;
                        if (!$ip1)
                            $error = '<div>Type alamat pertama</div>';
                        if (!$ip2)
                            $error .= '<div>Type alamat kedua</div>';
                        if (!$error && $ip1 > $ip2)
                            $error = 'Alamat kedua harus lebih besar dari alamat pertama';
                    }
                } elseif (stristr($ip, '*'))
                {
                    ////////////////////////////////////////////////////////////
                    // Proses alamat dengan masker                           //
                    ////////////////////////////////////////////////////////////
                    $iptmp = explode('*', $ip);
                    $ip = eregi_replace(".$", "", $iptmp[0]); // menghapus titip pada akhir
                    $iparr = explode('.', $ip); // Spilit oleh bagian
                    if (isset($iparr[2]))
                    {
                        $ip1 = $iparr[0] . '.' . $iparr[1] . '.' . $iparr[2] . '.0';
                        $ip2 = $iparr[0] . '.' . $iparr[1] . '.' . $iparr[2] . '.255';
                    } elseif (isset($iparr[1]))
                    {
                        $ip1 = $iparr[0] . '.' . $iparr[1] . '.0.0';
                        $ip2 = $iparr[0] . '.' . $iparr[1] . '.255.255';
                    } else
                    {
                        $ip1 = $iparr[0] . '.0.0.0';
                        $ip2 = $iparr[0] . '.255.255.255';
                    }
                    $ip1 = ip2long($ip1);
                    $ip2 = ip2long($ip2);
                    $mode = 2;
                    if (!$ip1)
                        $error = '<div>Type alamat</div>';
                } else
                {
                    ////////////////////////////////////////////////////////////
                    // Proses satu alamat                           //
                    ////////////////////////////////////////////////////////////
                    if (!ereg("^([0-9]{1,3})\.([0-9]{1,3})\.([0-9]{1,3})\.([0-9]{1,3})$", $ip))
                        $error = 'Type alamat IP';
                    $ip = ip2long($ip);
                    if (!$error && !$ip)
                        $error = 'Invalid masukan IP';
                    if (!$error)
                    {
                        $ip1 = $ip;
                        $ip2 = $ip;
                    }
                }
                if (!$error)
                {
                    ////////////////////////////////////////////////////////////
                    // Periksa konflik alamat                          //
                    ////////////////////////////////////////////////////////////
                    $req = mysql_query("SELECT * FROM `cms_ban_ip` WHERE ('" . $ip1 . "' BETWEEN `ip1` AND `ip2`) OR ('" . $ip2 . "' BETWEEN `ip1` AND `ip2`) OR (`ip1` >= '" . $ip1 . "' AND `ip2` <= '" . $ip2 . "')");
                    $total = @mysql_num_rows($req);
                    if ($total > 0)
                    {
                        echo '<div class="rmenu"><p> Konflik data rekaman ke alamat IP</p></div>';
                        while ($res = mysql_fetch_array($req))
                        {
                            echo ceil(ceil($i / 2) - ($i / 2)) == 0 ? '<div class="list1">' : '<div class="list2">';
                            $ip = $res['ip1'] == $res['ip2'] ? long2ip($res['ip1']) : long2ip($res['ip1']) . ' - ' . long2ip($res['ip2']);
                            echo '<a href="ipban.php?do=detail&amp;id=' . $res['id'] . '">' . $ip . '</a>';
                            switch ($res['ban_type'])
                            {
                                case 2:
                                    echo ' Mengerahkan ulang';
                                    break;

                                case 3:
                                    echo 'Daftar';
                                    break;

                                default:
                                    echo ' <b>Kunci</b>';
                            }
                            echo '</div>';
                            ++$i;
                        }
                        echo '<div class="phdr">Nilai: ' . $total . '</div>';
                        if ($total > $kmess)
                        {
                            echo '<p>' . pagenav('ipban.php?', $start, $total, $kmess) . '</p>';
                            echo '<p><form action="ipban.php" method="get"><input type="text" name="page" size="2"/><input type="submit" value="Ke Halaman &gt;&gt;"/></form></p>';
                        }
                        echo '<p><a href="ipban.php">Kembali</a><br /><a href="main.php">Ke Admin</a></p>';
                        require_once ("../incfiles/end.php");
                        exit;
                    }
                }
                // Periksa apakah IP tidak mendaptarkan administrator untuk zaban rentang
            if ($ipl >= $ip1 && $ipl <= $ip2)
                    $error = 'Anda sendiri alamat IP jatuh dalam kisaran';
                if (!$error)
                {
                    ////////////////////////////////////////////////////////////
                    // Window konfirmasi                                     //
                    ////////////////////////////////////////////////////////////
                    echo '<form action="ipban.php?do=insert" method="post">';
                    echo '<div class="gmenu">Periksa masukan data</div>';
                    switch ($mode)
                    {
                        case 1:
                            echo '<div class="menu"><p><u>Banim alamat rentang</u><br />[<b>' . long2ip($ip1) . '</b>] - [<b>' . long2ip($ip2) . '</b>]</p>';
                            break;
                        case 2:
                            echo '<div class="menu"><p><u>Pengenalan alamat yang akan di blokir rentang alamat</u><br />[<b>' . long2ip($ip1) . '</b>] - [<b>' . long2ip($ip2) . '</b>]</p>';
                            break;
                        default:
                            echo '<div class="menu"><p><u>Banim alamat</u><br /><b>' . long2ip($ip) . '</b></p>';
                    }
                    echo '<p><u>Jenis bana</u><br />';
                    switch ($ban_term)
                    {
                        case 2:
                            echo 'Mengarahkan ulang</p><p><u>Alamat redirect</u><br />' . (empty($ban_url) ? 'Default' : $ban_url);
                            break;
                        case 3:
                            echo 'Pendaftaran ditutup';
                            break;
                        default:
                            echo 'Kunci';
                    }
                    echo '</p><p><u>Alasan</u><br />' . (empty($reason) ? 'Tidak ada' : $reason) . '</p>';
                    echo '<input type="hidden" value="' . $ip1 . '" name="ip1" />';
                    echo '<input type="hidden" value="' . $ip2 . '" name="ip2" />';
                    echo '<input type="hidden" value="' . $ban_term . '" name="term" />';
                    echo '<input type="hidden" value="' . $ban_url . '" name="url" />';
                    echo '<input type="hidden" value="' . $reason . '" name="reason" />';
                    echo '</div><div class="bmenu"><input type="submit" name="submit" value="Banit"/></div>';
                    echo '</form>';
                    echo '<p><a href="ipban.php">Batal</a><br /><a href="main.php">Ke Admin</a></p>';
                } else
                {
                    echo '<p>ERROR!<br />' . $error . '<br /><a href="ipban.php?do=new">Kembali</a></p>';
                }
            } else
            {
                ////////////////////////////////////////////////////////////
                // Form memasukan alamat IP untuk Bana                         //
                ////////////////////////////////////////////////////////////
                echo '<form action="ipban.php?do=new" method="post">';
                echo '<div class="menu"><u>Masukan alamat IP</u><p>';
                echo '<input type="text" name="ip"/><br />';
                echo '<small>Banit dapat satu alamat,alamat dan berbagai topeng,Contoh:<br />';
                echo '<font color="#FF0000">10.5.7.1</font> - Banim satu alamat<br />';
                echo '<font color="#FF0000">10.5.7.1-10.5.7.100</font> - Banim pada kisaran alamat.<br />';
                echo 'PERINGATAN!! Dalam rentang alamat anda didak dapat menggunakan masker *<br />';
                echo '<font color="#FF0000">10.5.*.*</font> - Banim pada masker,Akan diblokir semua subnet alamat dimulai dengan 0-255';
                echo '</small></p></div>';
                echo '<div class="menu"><u>Jenis Bana</u><p>';
                echo '<input name="term" type="radio" value="1" checked="checked" />Kunci<br />';
                echo '<input name="term" type="radio" value="3" />Tutup Registrasi<br />';
                echo '<input name="term" type="radio" value="2" />Mengarahkan ulang<br /></p>';
                echo '<p><u>URL Redirect</u><br /><small>opsional</small><br />';
                echo '<input type="text" name="url"/><br />';
                echo '<small>Alamat yang anda masukan dalam format http://url.com</small></p></div>';
                echo '<div class="menu"><u>Alasan Bana</u><br /><p><small>opsional</small><br />';
                echo '<textarea cols="25" rows="4" name="reason"></textarea></p></div>';
                echo '<div class="bmenu"><input type="submit" name="submit" value="Banit"/></div>';
                echo '</form>';
                echo '<p><a href="ipban.php">Batal</a><br /><a href="main.php">Ke Admin</a></p>';
            }
            break;

        case 'insert':
            ////////////////////////////////////////////////////////////
            // Periksa alamat dan memasukan ke dalam database                     //
            ////////////////////////////////////////////////////////////
            $ip1 = isset($_POST['ip1']) ? intval($_POST['ip1']):
            '';
            $ip2 = isset($_POST['ip2']) ? intval($_POST['ip2']):
            '';
            $ban_term = isset($_POST['term']) ? intval($_POST['term']):
            1;
            $ban_url = isset($_POST['url']) ? trim($_POST['url']):
            '';
            $reason = isset($_POST['reason']) ? trim($_POST['reason']):
            '';
            if (!$ip1 || !$ip2)
            {
                echo '<p>ERROR!<br />Alamat IP yang tidak terdaftar<br /><a href="main.php">Ke Admin</a></p>';
                require_once ("../incfiles/end.php");
                exit;
            }
            mysql_query("INSERT INTO `cms_ban_ip` SET
         `ip1`='" . $ip1 . "',
         `ip2`='" . $ip2 . "',
         `ban_type`='" . $ban_term . "',
         `link`='" . check($ban_url) . "',
         `who`='" . $login . "',
         `reason`='" . check($reason) . "',
         `date`='" . $realtime . "';");
            echo '<p>Ban ditambahkan ke database.</p>';
            echo '<p><a href="ipban.php">Lanjutkan</a><br /><a href="main.php">Ke Admin</a></p>';
            break;

        case 'clear':
            ////////////////////////////////////////////////////////////
            // Hapus tabel Banovo pada IP                            //
            ////////////////////////////////////////////////////////////
            if (isset($_GET['yes']))
            {
                mysql_query("TRUNCATE TABLE `cms_ban_ip`;");
                echo '<p>Tabel IP Ban Berhasil dihapus.<br />Razban Semua alamat.</p>';
                echo '<p><a href="ipban.php">Lanjutkan</a><br /><a href="main.php">Ke Admin</a></p>';
            } else
            {
                echo '<p><b>PERINGATAN!</b><br />Ban Tabel IP akan dihapus.<br />Apakah anda benar benar akan razbanit semua alamat IP?</p>';
                echo '<p><a href="ipban.php">Batal</a><br /><a href="ipban.php?do=clear&amp;yes=yes">Ya, razban</a></p><p><a href="main.php">Ke Admin</a></p>';
            }
            break;

        case 'detail':
            echo '<div class="phdr"> IP Terkunci</div>';
            if ($id)
            {
                ////////////////////////////////////////////////////////////
                // Cari alamat pada link (ID)                            //
                ////////////////////////////////////////////////////////////
                $req = mysql_query("SELECT * FROM `cms_ban_ip` WHERE `id` = '" . $id . "' LIMIT 1");
                $ip = '';
            } elseif (isset($_POST['ip']))
            {
                ////////////////////////////////////////////////////////////
                // Cari alamat pada permintaan dalam bentuk                       //
                ////////////////////////////////////////////////////////////
                $ip = ip2long($_POST['ip']);
                if (!$ip)
                {
                    echo '<p>ERROR! Alamat IP yang dimasukan salah<br /><br /><a href="main.php">Ke Admin</a></p>';
                    require_once ("../incfiles/end.php");
                    exit;
                }
                $req = mysql_query("SELECT * FROM `cms_ban_ip` WHERE '" . $ip . "' BETWEEN `ip1` AND `ip2` LIMIT 1");
            } else
            {
                echo '<p>ERROR!<br /><a href="main.php">Ke Admin</a></p>';
                require_once ("../incfiles/end.php");
                exit;
            }
            if (mysql_num_rows($req) != 1)
            {
                echo '<p>Alamat IP ini belum ada didata base.</p>';
                echo '<p><a href="ipban.php">Kembali</a><br /><a href="main.php">Ke Admin</a></p>';
                require_once ("../incfiles/end.php");
                exit;
            } else
            {
                $res = mysql_fetch_array($req);
                $ip = $res['ip1'] == $res['ip2'] ? '<b>' . long2ip($res['ip1']) . '</b>' : '[<b>' . long2ip($res['ip1']) . '</b>] - [<b>' . long2ip($res['ip2']) . '</b>]';
                echo '<div class="rmenu"><p>' . $ip . '</p></div>';
                echo '<div class="menu"><p><u>Jenis Ban</u><br />';
                switch ($res['ban_type'])
                {
                    case 2:
                        echo ' Mengarahkan ulang link.';
                        break;

                    case 3:
                        echo ' Larang pendaftaran.';
                        break;

                    default:
                        echo ' Blokir akses ke situs ini.';
                }
                if ($res['ban_type'] == 2)
                    echo '<br />mengarahkan ulang: ' . $res['link'];
                echo '</p><p><u>Alasan</u><br />' . (empty($res['reason']) ? 'Tidak ada' : $res['reason']) . '</p></div>';
                echo '<div class="menu">Banil: <b>' . $res['who'] . '</b><br />';
                echo 'Tanggal: <b>' . date('d.m.Y', $res['date']) . '</b><br />';
                echo 'Waktu: <b>' . date('H:i:s', $res['date']) . '</b></div>';
                echo '<div class="bmenu"><a href="ipban.php?do=del&amp;id=' . $res['id'] . '">Razbanit</a></div>';
                echo '<p><a href="ipban.php">Kembali</a><br /><a href="main.php">Ke Admin</a></p>';
            }
            break;

        case 'del':
            ////////////////////////////////////////////////////////////
            // Hapus IP terpilih dari database                         //
            ////////////////////////////////////////////////////////////
            if ($id)
            {
                if (isset($_GET['yes']))
                {
                    mysql_query("DELETE FROM `cms_ban_ip` WHERE `id`='" . $id . "' LIMIT 1");
                    mysql_query("OPTIMIZE TABLE `cms_ban_ip`");
                    echo '<p>Ban berhasil dihapus dari database</p>';
                    echo '<p><a href="ipban.php">Lanjut</a><br /><a href="main.php">ke Admin</a></p>';
                } else
                {
                    $req = mysql_query("SELECT * FROM `cms_ban_ip` WHERE `id`='" . $id . "' LIMIT 1");
                    if (mysql_num_rows($req) != 1)
                    {
                        echo '<p>Alamat ini belum ada didatabase.</p>';
                        echo '<p><a href="ipban.php">Kembali</a><br /><a href="main.php">Admin</a></p>';
                        require_once ("../incfiles/end.php");
                        exit;
                    } else
                    {
                        echo '<p>Apakah anda yakin dengan alamat razbanit?</p>';
                        echo '<p><a href="ipban.php?do=del&amp;id=' . $id . '&amp;yes=yes">Razbanit</a><br /><a href="ipban.php?do=detail&amp;id=' . $id . '">Batal</a></p>';
                    }
                }
            }
            break;

        case 'search':
            ////////////////////////////////////////////////////////////
            // Cari formulir zabanennogo IP                            //
            ////////////////////////////////////////////////////////////
            echo '<div class="phdr"><b>Cari alamat IP yang diblokir</b></div>';
            echo '<form action="ipban.php?do=detail" method="post">';
            echo '<div class="menu"><u>Masukan Alamat IP</u>';
            echo '<p><input type="text" name="ip"/></p></div>';
            echo '<div class="bmenu"><input type="submit" name="submit" value="Poisk"/></div>';
            echo '</form>';
            echo '<p><a href="ipban.php">Kembali</a><br /><a href="main.php">Ke Admin</a></p>';
            break;

        default:
            ////////////////////////////////////////////////////////////
            // Output umum zabanennyh daftar IP                      //
            ////////////////////////////////////////////////////////////
            echo '<div class="phdr"><b>Ban dari IP</b></div>';
            $req = mysql_query("SELECT COUNT(*) FROM `cms_ban_ip`");
            $total = mysql_result($req, 0);
            if ($total > 0)
            {
                $start = isset($_GET['page']) ? $page * $kmess - $kmess : $start;
                $req = mysql_query("SELECT * FROM `cms_ban_ip` ORDER BY `id` ASC LIMIT " . $start . "," . $kmess . ";");
                while ($res = mysql_fetch_array($req))
                {
                    echo ceil(ceil($i / 2) - ($i / 2)) == 0 ? '<div class="list1">' : '<div class="list2">';
                    $ip = $res['ip1'] == $res['ip2'] ? long2ip($res['ip1']) : long2ip($res['ip1']) . ' - ' . long2ip($res['ip2']);
                    echo '<a href="ipban.php?do=detail&amp;id=' . $res['id'] . '">' . $ip . '</a>';
                    switch ($res['ban_type'])
                    {
                        case 2:
                            echo ' mengerahkan ulang';
                            break;

                        case 3:
                            echo ' Daftar';
                            break;

                        default:
                            echo ' <b>Kunci</b>';
                    }
                    echo '</div>';
                    ++$i;
                }
                echo '<div class="phdr">Nilai: ' . $total . '</div>';
                if ($total > $kmess)
                {
                    echo '<p>' . pagenav('ipban.php?', $start, $total, $kmess) . '</p>';
                    echo '<p><form action="ipban.php" method="get"><input type="text" name="page" size="2"/><input type="submit" value="Ke Halaman &gt;&gt;"/></form></p>';
                }
            } else
            {
                echo '<div class="menu">Daftar kosong</div>';
                echo '<div class="phdr">&nbsp;</div>';
            }
            echo '<p><a href="ipban.php?do=new">Banit IP</a><br />';
            if ($total > 0)
                echo '<a href="ipban.php?do=search">Cari dalam database</a><br /><a href="ipban.php?do=clear">Razbanit semua IP</a>';
            echo '</p><p><a href="main.php">Ke Admin</a></p>';
    }
} else
{
    header("Location: ../index.php?err");
}
require_once ("../incfiles/end.php");

?>